/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: ThreadCPULoadEntryPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the ThreadCPULoadEntryPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=ThreadCPULoadEntry.class)
public class ThreadCPULoadEntryPointer extends StructurePointer {

	// NULL
	public static final ThreadCPULoadEntryPointer NULL = new ThreadCPULoadEntryPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected ThreadCPULoadEntryPointer(long address) {
		super(address);
	}

	public static ThreadCPULoadEntryPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static ThreadCPULoadEntryPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static ThreadCPULoadEntryPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new ThreadCPULoadEntryPointer(address);
	}

	public ThreadCPULoadEntryPointer add(long count) {
		return ThreadCPULoadEntryPointer.cast(address + (ThreadCPULoadEntry.SIZEOF * count));
	}

	public ThreadCPULoadEntryPointer add(Scalar count) {
		return add(count.longValue());
	}

	public ThreadCPULoadEntryPointer addOffset(long offset) {
		return ThreadCPULoadEntryPointer.cast(address + offset);
	}

	public ThreadCPULoadEntryPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public ThreadCPULoadEntryPointer sub(long count) {
		return ThreadCPULoadEntryPointer.cast(address - (ThreadCPULoadEntry.SIZEOF * count));
	}

	public ThreadCPULoadEntryPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public ThreadCPULoadEntryPointer subOffset(long offset) {
		return ThreadCPULoadEntryPointer.cast(address - offset);
	}

	public ThreadCPULoadEntryPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public ThreadCPULoadEntryPointer untag(long mask) {
		return ThreadCPULoadEntryPointer.cast(address & ~mask);
	}

	public ThreadCPULoadEntryPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return ThreadCPULoadEntry.SIZEOF;
	}

	// Implementation methods

	// float system
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_systemOffset_", declaredType="float")
	public float system() throws CorruptDataException {
		return getFloatAtOffset(ThreadCPULoadEntry._systemOffset_);
	}

	// float system
	public FloatPointer systemEA() throws CorruptDataException {
		return FloatPointer.cast(nonNullFieldEA(ThreadCPULoadEntry._systemOffset_));
	}

	// U32 threadIndex
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_threadIndexOffset_", declaredType="U32")
	public UDATA threadIndex() throws CorruptDataException {
		return new U32(getIntAtOffset(ThreadCPULoadEntry._threadIndexOffset_));
	}

	// U32 threadIndex
	public UDATAPointer threadIndexEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(ThreadCPULoadEntry._threadIndexOffset_));
	}

	// I64 ticks
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ticksOffset_", declaredType="I64")
	public IDATA ticks() throws CorruptDataException {
		return new I64(getLongAtOffset(ThreadCPULoadEntry._ticksOffset_));
	}

	// I64 ticks
	public IDATAPointer ticksEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(ThreadCPULoadEntry._ticksOffset_));
	}

	// float user
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_userOffset_", declaredType="float")
	public float user() throws CorruptDataException {
		return getFloatAtOffset(ThreadCPULoadEntry._userOffset_);
	}

	// float user
	public FloatPointer userEA() throws CorruptDataException {
		return FloatPointer.cast(nonNullFieldEA(ThreadCPULoadEntry._userOffset_));
	}

}
